=begin
(c) SketchUcation [SCF] / TIG 2015
###
All rights reserved.
THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES; 
INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
FITNESS FOR A PARTICULAR PURPOSE.
###
SCF_loader.rb
Loads SketchUcation tools from their subfolder.
=end
###
### tidy
tidied=false
if File.exist?(File.join(SCF::FOLDER, "Upload2sketchUview.rb"))
	File.delete(File.join(SCF::FOLDER, "Upload2sketchUview.rb"))
	tidied=true
end
if File.exist?(File.join(SCF::FOLDER, "sketchUcloud.rb"))
	File.delete(File.join(SCF::FOLDER, "sketchUcloud.rb"))
	tidied=true
end
if File.exist?(File.join(SCF::FOLDER, "Data.txt"))
	File.delete(File.join(SCF::FOLDER, "Data.txt"))
end
###
module SCF
	def self.loadRBS(path)
		return if path=~/rbe$/ && SketchUp.version.to_i <= 15
		pos=nil
		$".each_with_index{|p, i| (pos=i; break) if p==path || p=~/(#{path})\.(rb|rbs|rbe)\z/i }
		$".delete_at(pos) if pos
		#Sketchup::require(path)
		Kernel::eval(
			"Sketchup::require(\"#{path}\")",
			TOPLEVEL_BINDING,  # eval in this scope
			path,  # report errors on this filename
			1      # begin reporting errors at line 1
		)
	end
end
###
### Load Dialog first
SCF.loadRBS(File.join(SCF::FOLDER, "SCF_Dialog"))
### Now the rest...
###
["!SCFapiTools",
	"SCF_Manager",
	"SCF_Uninstaller",
	"SCF-RBZtools",
	"SCF-myShortcuts",
	"SCF-openPluginsFolder",
	"sketchUcloud"
].each{|r|
	path = File.join(SCF::FOLDER, r)
	hits = []
	[".rbe",
		".rbs",
		".rb"
	].each{|x|
		pathx = path+x
		hits << pathx if File.exist?(pathx)
	}
	hits = [hits[0]]
	SCF.loadRBS(File.join(hits[0])) if hits[0] ### now we load it
}
###
module SCF
	if defined?(Encoding)
		me=File.basename(__FILE__).force_encoding("UTF-8")
	else	
		me=File.basename(__FILE__)
	end
	unless file_loaded?(me)
		###
		SUBMENU = UI.menu("Plugins").add_submenu(LNAME)
		TOOLBAR = UI::Toolbar.new(DESC)
		### Make store cmds
		cmd = UI::Command.new(DESC){SCF_Dialog.new()}
		cmd.tooltip = "#{DESC}"
		cmd.status_bar_text = "#{SBT}"
		cmd.small_icon = File.join(IMAGES, 'SCF-16.png')
		cmd.large_icon = File.join(IMAGES, 'SCF-24.png')
		###
		SUBMENU.add_item(cmd)
		TOOLBAR.add_item(cmd)
		### Make plugins manager cmds
		cmd = UI::Command.new(MDESC){SCFmanager.new()}
		cmd.tooltip = "#{MDESC}"
		cmd.status_bar_text = "#{MSBT}"
		cmd.small_icon = File.join(IMAGES, 'SCFm-16.png')
		cmd.large_icon = File.join(IMAGES, 'SCFm-24.png')
		###
		SUBMENU.add_item(cmd)
		TOOLBAR.add_item(cmd)
		### Make extensions manager cmds
		cmd = UI::Command.new(XDESC){SCFmanagerX.new()}
		cmd.tooltip = "#{XDESC}"
		cmd.status_bar_text = "#{XSBT}"
		cmd.small_icon = File.join(IMAGES, 'SCFx-16.png')
		cmd.large_icon = File.join(IMAGES, 'SCFx-24.png')
		###
		SUBMENU.add_item(cmd)
		TOOLBAR.add_item(cmd)
		### Make install_archive to custom-plugins
		cmd = UI::Command.new(CDESC){RBZtool.archiveInstaller()}
		cmd.tooltip = "#{CDESC}"
		cmd.status_bar_text = "..."
		###
		SUBMENU.add_item(cmd)
		### Make plugin uninstaller
		cmd = UI::Command.new(UDESC){SCFuninstaller.new()}
		cmd.tooltip = "#{UDESC}"
		cmd.status_bar_text = "..."
		###
		SUBMENU.add_item(cmd)
		###
		SUBMENU.add_item("#{TOOLBARTOGGLE}"){(TOOLBAR.visible?) ? TOOLBAR.hide : TOOLBAR.show}
		###
		TOOLBAR.show if TOOLBAR.get_last_state.abs == 1 # TB_VISIBLE/NEVER
		###
	end#unless
	file_loaded(me)
	###
	@model=Sketchup.active_model
	@defns=@model.definitions
	### remove rogue files from v1.1.1
	Dir.entries(PLUGINS).each{|f|
		File.delete(File.join(PLUGINS, f)) if f =~ /^SketchUcationTools-v1-1-1.rbz/
	}
	###
end#module
###
###
UI.messagebox("Please restart SketchUp to complete the installation/update of the SkechUcation Toolset...") if tidied
###
